<?php
/*
 * Plugin Name: Free Dcitys
 * Description: Free Dcitys 多城市站群插件，内置 <strong>3700+</strong> 县市城市，分站可自动添加对应的城市名称，<strong>部分主题可能不支持此插件功能</strong>。
 * Version: 1.0.4
 * Author: Dcitys.cn
 * Author URI: //dcitys.cn
 */
defined( 'ABSPATH' ) || exit;

define( 'Free_Dcitys_VERSION', '1.0.4');
define( 'FREE_Dcitys_DIR', plugin_dir_path( __FILE__ ) );

$Free_Dcitys_info = array(
        'slug' => 'Free_Dcitys',
        'name' => 'Free_Dcitys',
        'ver' => Free_Dcitys_VERSION,
        'title' => '城市站群(免费版)',
        'plugin_id' => '22626adcc5674a5d',
        'basename' => plugin_basename( __FILE__ )
);

new Free_Dcitys($Free_Dcitys_info);

class Free_Dcitys{
    public $updateName = 'plugin_update_free_dcitys';
    
    public function __construct( $args ){
        $this->basename=$args['basename'];
        $this->version=$args['ver'];
        $this->op=include_once(FREE_Dcitys_DIR.'config.php');
        $this->citys=include_once(FREE_Dcitys_DIR.'city_list.php');
        $this->host=$_SERVER['HTTP_HOST'];
        $this->http=wp_is_using_https()?'https://':'http://';
        add_filter( 'site_transient_update_plugins', array($this,'checkUpdates'));
        add_action( 'init', array($this,'init') );
        add_filter('option_blogname', array($this,'replaceTitle'),10,2);
        add_filter('the_title', array($this,'replaceTitle'),10,2);
        add_action('wp_head',array($this,'obStart'),0);
        add_action('wp_head',array($this,'obEnd'),9999);
        add_shortcode('city_name',array($this,'shortCityName'));
        
        if(!(strpos($_SERVER['PHP_SELF'],'wp-admin') !== false)){
            add_filter('wp_title', array($this,'replaceTitle'),999,2);
            add_filter('document_title', array($this,'replaceTitle'),999,2);
        }
        
        if(isset($this->op['FOOTER_LINKS'])&&intval($this->op['FOOTER_LINKS'])>0){
            if($this->op['FOOTER_LINK_POS']==1){
                add_action( 'wp_footer', array($this,'footerLinks'));
            }else{
                add_action( 'get_footer', array($this,'footerLinks'));
            }
        }
    }
    
    public function init(){
        $city_pre=isset($this->op['CITY_PRE'])&&$this->op['CITY_PRE']?$this->op['CITY_PRE']:'city_';
        if(isset($this->op['URL_MODEL'])&&$this->op['URL_MODEL']==1){
            remove_filter('template_redirect', 'redirect_canonical');
            preg_match('/'.$city_pre.'[0-9a-zA-Z_-]*/i',$_SERVER['REQUEST_URI'], $dir_city);
            if(isset($dir_city[0])&&$dir_city[0]!=$city_pre){
                $dir_city=str_ireplace($city_pre,'',$dir_city[0]);
                $_SERVER['REQUEST_URI']=preg_replace('/'.$city_pre.'[0-9a-zA-Z_-]*/i', '', $_SERVER['REQUEST_URI']);
                $this->setCity($dir_city);
            }
        }elseif(isset($this->op['URL_MODEL'])&&$this->op['URL_MODEL']==2){
            define('WP_SITEURL', $this->http . $this->host);
            define('WP_HOME', $this->http . $this->host);
            $hostArr=explode('.',$_SERVER['HTTP_HOST']);
            if($hostArr[0]!='www'){
                $this->setCity($hostArr[0]);
            }
        }else{
            isset($_GET[$city_pre])&&$this->setCity($_GET[$city_pre]);
        }
        add_action( 'wp_footer', array($this,'addUrlCity') );
        
        add_filter( sprintf( '%splugin_action_links_%s', '', $this->basename ), function ( $links ) {
            return array_merge(
                $links,
                [ sprintf( '<a style="color:#FD6900;font-weight:700;" target="_blank" href="%s">%s</a>', 'https://dcitys.cn', '获取专业版' ) ]
            );
        });
    }
    
    //设置当前分站城市信息
    public function setCity($city_key=''){
        $this->city=array(
            'key'=>$city_key,
            'title'=>$this->citys[$city_key]
        );
        $GLOBALS['city']=$this->city;
    }
    
    //url 添加城市信息
    public function addUrlCity(){
        if(!isset($this->city))return;
        $city_pre=isset($this->op['CITY_PRE'])&&$this->op['CITY_PRE']?$this->op['CITY_PRE']:'city_';
        if($this->op['URL_MODEL']==1){
        ?>
            <script>
                (function(){
                    a_len=document.getElementsByTagName("a").length;
                    for(i=0;i<a_len;i++){
                        href=document.getElementsByTagName("a")[i].getAttribute('href') + "";
                        if(href.indexOf(document.domain)>=0&&href.indexOf("<?php echo $city_pre;?>")<0){
                            n_href=href.replace(document.domain, document.domain+"/<?php echo $city_pre.$this->city['key'];?>");
                            document.getElementsByTagName("a")[i].setAttribute("href",n_href);
                        }
                    }
                })();
            </script>
        <?php
        }elseif($this->op['URL_MODEL']==2){
            ?>
            <script>
                (function(){a_len=document.getElementsByTagName("a").length;
                    for(i=0;i<a_len;i++){
                        href=document.getElementsByTagName("a")[i].getAttribute('href') + "";
                        if(href=="javascript:;" ||href==undefined||href.indexOf("<?php echo $city_pre;?>")>0||href=="/"||href.indexOf("#")>=0||href.indexOf(document.domain)==-1){
                        }else{
                            if( href.indexOf("?")>0 ){
                                n_href=href + "&<?php echo $city_pre;?>=<?php echo $this->city['key'];?>"
                            }else{
                                n_href=href + "?<?php echo $city_pre;?>=<?php echo $this->city['key'];?>"
                            }
                            document.getElementsByTagName("a")[i].setAttribute("href",n_href);
                        }
                    }
                })();
            </script>
            <?php
        }
    }
    
    //网站底部链接
    public function footerLinks(){
         //shuffle($this->citys);
         $citys=array_slice($this->citys,mt_rand(0,count($this->citys)-$this->op['FOOTER_LINKS']),$this->op['FOOTER_LINKS']);
         $links='';
         echo '<style>.dcitys_footer_link{width:85%;margin:1em auto;max-width:'.$this->op['FOOTER_WIDTH'].'}.dcitys_footer_link a{font-size:'.$this->op['FOOTER_FONT_SIZE'].'}.dcitys_footer_link a+a{padding-left:1em}</style>';
         foreach($citys as $k=>$v){
             $rand_k=$this->op['KEYWORDS'][array_rand($this->op['KEYWORDS'],1)];
             $links.='<a class="dcitys-link" href="'.$this->url($k).'" title="'.$v.$rand_k.'">'.$v.$rand_k.'</a>';
         }
         echo '<div class="dcitys_footer_link">'.$links.'</div>';
    }
    
    //生成url
    public function url($key){
        if(isset($this->op['URL_MODEL'])&&$this->op['URL_MODEL']==1){
            return $this->http.$this->host.'/'.$this->op['CITY_PRE'].$key;
        }elseif(isset($this->op['URL_MODEL'])&&$this->op['URL_MODEL']==2){
            return $this->http.$key.'.'.$this->host;
        }else{
            return $this->http.$this->host.'?'.$this->op['CITY_PRE'].'='.$key;
        }
    }
    
     //替换城市名
    public function replaceTitle($title){
        $name=$this->city['title']??'';
        return str_ireplace('[city_name]',$name,$title);
    }
    
    public function obStart(){
        ob_start();
    }
    public function obEnd(){
        $seo=ob_get_contents();
        ob_clean();
        global $city;
        $cityName=isset($city['title'])?$city['title']:'';
        $seo=str_ireplace('[city_name]',$cityName,$seo);
        echo $seo;
    }
    
    public function shortCityName(){
        global $city;
        return $city['title']??'';
    }
    
    //检查更新
    public function checkUpdates($transient) {
        if (empty($transient->checked)) {
            return $transient;
        }
        $plugin_update_state = get_option($this->updateName);
        if ( !empty($plugin_update_state) && isset($plugin_update_state->update) && !empty($plugin_update_state->update) ){
            $update = $plugin_update_state->update;
            if($update->version && version_compare($update->version, $this->version) > 0){
                $transient->response[$this->basename] = array(
                    'slug' => $this->basename,
                    'new_version' => $update->version,
                    'package' => $update->package,
                );
               
                $transient->response[$this->basename] = json_decode(json_encode($transient->response[$this->basename]));
                return $transient;
            }else{
                update_option($this->updateName, '');
            }
        }
        if (time()-$transient->last_checked<=1*60*60) {
            return $transient;
        }
       
        $plugin_remote_path = 'https://plugins.dcitys.cn/json/free_dcitys_info.php';

        $response = wp_remote_get($plugin_remote_path);
        if (is_wp_error($response)) {
            return $transient;
        }
       
        $remote_info = json_decode(wp_remote_retrieve_body($response), true);
        if (!isset($remote_info['version']) || !isset($remote_info['package'])) {
            return $transient;
        }
  
        if (version_compare($this->version, $remote_info['version'], '<')) {
            $transient->response[$this->basename] = array(
                'slug' => $this->basename,
                'new_version' => $remote_info['version'],
                'package' => $remote_info['package'],
            );
            $transient->response[$this->basename] = json_decode(json_encode($transient->response[$this->basename]));
            $state = new StdClass;
            $state->lastCheck = time();
            $state->update = new StdClass;
            $state->update->version = $remote_info['version'];
            $state->update->package = $remote_info['package'];
            update_option($this->updateName, $state);
            wp_cache_delete( $this->updateName, 'options' );
        }
        return $transient;
    } 
}





